#!/usr/bin/perl -w
#...................................................................#
# Sanitarium WebLoG: web publish system.............................#
# Author: Green Kakadu (WebScript.Ru Network) ......................#
# Email: gnezdo@webscript.ru .......................................#
# WWW: http://webscript.ru .........................................#
# Copyright 2002 WebScript.Ru Network ( http://webscript.ru ).......#
# All Rights Reserved. .............................................#
#...................................................................#

#	Welcome to where time stands still
#	no one leaves and no one will
#	Moon is full, never seems to change
#	just labeled mentally deranged
#	Dream the same thing every night
#	I see our freedom in my sight
#	No locked doors, No windows barred
#	No things to make my brain seem scarred
#...................	Metallica, "Welcome Home (Sanitarium)"


#...................................................................#
# File name: admin.cgi                          ....................#
#...................................................................#

use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars '$time_view','$script_admin', '$ext', '$img_url', '$tmpl_dir', '$data', '$public_dir', '$use_emoticons', '$public_url', '$use_flock', '$dir', '%msg', '%in', '$builder',
'$index_url', '$index_page', '$entry_per_page', '$static_pages', '$view_cgi_url', '$site_title', '$how_news', '$use_search', '$not_found', '$foto_url',
'$premoderate', '$send_new_comments', '$admin_mail', '$SEND_MAIL', '$comadmin_cgi_url', '$comment_url', '$mail_cgi_url', '$coms_per_page', '$foto_dir', '$img_dir', '$GMT', '$upload_url', '$autolink',
'$qhtml', '$fozzy', '$txt_news';
#....Load Libraries 
eval { 
require "cfg.cfg";
require "Sanitarium_WL.pm";
require "lang.pl";
};
#....If not Libraries
if ($@){
	print "Content-type: text/html\n\n";
	print "ERROR including libraries: $@";
	exit;
	}
#flock() options:
$Sanitarium_WL::USE_FLOCK=$use_flock;
$Sanitarium_WL::USE_FLOCK||=0;	

#Own Error Logs.
#$SIG{__DIE__} =sub {
#		open (LOG, ">>log.txt");
#		print LOG @_,"\n";
#		close LOG;
#		warn(@_);
#		exit;
#		};

#....RUN main subrouting	
eval {
&main
};
#....If Errors
if ($@){ 
&WLerr("Error: $@");
}
exit;


sub main {
#--------------------------------------------------------------   
$script_admin||=$ENV{'SCRIPT_NAME'};
if ($ENV{'REQUEST_METHOD'}){%in=&parse_form;}

#......CATEGORY
if ($in{'new_cat'})              {&create_category;}
elsif ($in{'save_mod_category'}) {&save_category;}
elsif ($in{'save_category'})     {&save_category;}
elsif ($in{'delete_category'})   {&delete_category;}
elsif ($in{'view_category'})     {&view_category;}
elsif ($in{'modify_category'})   {&create_category;}

#......ARTICLES
elsif ($in{'new_article'})                      {&add_article;}
elsif ($in{'save_mod_article'})                 {&save_article;}
elsif ($in{'save_article'})                     {&save_article;}
elsif ($in{'delete_article'})                   {&delete_article;}
elsif ($in{'modify'})                           {&mod_article;}
elsif ($in{'search_id'})                        {&mod_by_id;}
elsif ($in{'search_view'})                      {&mod_by_id;}
elsif ($in{'mod_art_options'})                  {&mod_article_options;}
elsif ($in{'save_new_options'})                 {&mod_article_options;}
elsif ($in{'index_article'}&&$use_search)       {&indexing_article}
elsif ($in{'delete_from_index'}&&$use_search)   {&delete_article_from_index;}
elsif ($in{'delete_from_index_y'}&&$use_search) {&delete_article_from_index;}

#.....ARTICLE'S PAGES
elsif ($in{'modify_article'})    {&add_article(1);}
elsif ($in{'delete_page'})       {&delete_page;}
elsif ($in{'add_page'})          {&add_article(666);}

#.....TEMPLATE EDITOR
elsif ($in{'new_template'})      {&template_edit;}
elsif ($in{'modify_template'})   {&select_template;}
elsif ($in{'mod_templ_but'})     {&save_template;}
elsif ($in{'new_templ_but'})     {&save_template(1);}
elsif ($in{'view_template'})     {&view_template;}

#....AUTHORS
elsif ($in{'add_author'})        {&add_author;}
elsif ($in{'modify_author'})     {&add_author;}
elsif ($in{'save_mod_author'})   {&save_author;}
elsif ($in{'save_new_author'})   {&save_author;}
elsif ($in{'view_author'})       {&author_info;}
elsif ($in{'save_new_author'})   {&save_author;}
elsif ($in{'delete_author'})     {&delete_author;}

#....BUILDER
elsif ($in{'rebuild_all'})       {&rebuild_all;}
elsif ($in{'rebuild_cat'})       {&rebuild_category;}
elsif ($in{'article_rebuild'})   {&article_rebuild;}

#....MISC
elsif ($in{'list_files'})        {&print_file_list;}
elsif ($in{'delete_files'})      {&delete_files;}
elsif ($in{'delete_this'})       {&delete_files;}
#.....START
else                             {&start_page;}
}


#.......#ADMIN ROUTINGS
#######################

#......#CATEGORY
sub create_category {
#----------------------------------------------------------------------
my ($obj, $value, $name, %category);
if ($in{'cat_id'}){
	#CREATE OBJECT
	$obj = new Sanitarium_WL ("$data/categories", 'categories');
	%category = $obj->get_data($in{'cat_id'});
	#DESTROY
	$obj=0;
	$value='Modify!';
	$name='save_mod_category';#don't change it value
}
else {
	$value='Create!';
	$name='save_category';#don't change it value
	undef %category;
}	
#Print Page
&head;
print qq~
<form action="$script_admin" METHOD="POST">
<input type=hidden name="cat_id" value="$in{'cat_id'}">
~;
#Print input fields:
&table($msg{'cat_name'}.':', &input_form('cat_name', 70, 100, $category{'cat_name'}));
&table($msg{'cat_desc'}.':', &textarea('cat_description', 50, 5, $category{'cat_description'}));
&table($msg{'cat_keywords'}.':', &textarea('cat_keywords', 50, 5, $category{'cat_keywords'}));

&table($msg{'template'}.':', &drop_list('template',$category{'template'}, &template_list));
print qq~
<input type=SUBMIT name="$name" value="$value" class="form1"></form>
~;
&foot;
}

sub save_category {
#---------------------------------------------------------------------
my ($obj, $key, $html, %index);
#my $option=shift;#Modify or create new?
#Check %in 
unless ($in{'cat_name'}){&msg('You must input <b>Category Name</b>!');}
unless ($in{'cat_description'}){&msg('You must input <b>Category Description</b>!');}
unless ($in{'template'}){&msg('You must select <b>Category Template</b>')}

#CREATE Object
$obj = new Sanitarium_WL ("$data/categories", 'categories');
#if modify, than modify it!
#Fields: categories  =>['cat_name', 'cat_description', 'cat_keywords', 'template']
if ($in{'cat_id'}){
	$obj->modify_data($in{'cat_id'},
	                  $in{'cat_name'},
	                  $in{'cat_description'},
	                  $in{'cat_keywords'},
	                  $in{'template'});
}
#Else Create new!
else {
	$key=$obj->write_data('1cat',
	                  $in{'cat_name'},
	                  $in{'cat_description'},
	                  $in{'cat_keywords'},
	                  $in{'template'});
}
$obj=0;
$key||=$in{'cat_id'};
#Check category dir
if (!(-e "$data/$key")){
	mkdir("$data/$key", 0777) or &WLerr("Can't mkdir $data/$key , reason: $!");
	chmod(0777, "$data/$key") or &WLerr("Can't chmod $data/$key , reason: $!");
	
}
if (!(-e "$public_dir/$key")){
	mkdir("$public_dir/$key", 0777) or &WLerr("Can't mkdir $public_dir/$key , reason: $!");
	chmod(0777, "$public_dir/$key") or &WLerr("Can't chmod $public_dir/$key , reason: $!");
}		
#Create Category DB
$obj= new Sanitarium_WL("$data/$key", 'index');
$obj->create_db();
$obj=0;
	                         
$html=&category_info($key, $in{'cat_name'}, $in{'cat_description'}, $in{'cat_keywords'}, $in{'template'});
&head;
&table($msg{'info'}.':', $html);
&foot;
}

sub delete_category {
#---------------------------------------------------------------------
my ($obj, $html, @del_keys, %category);
$obj= new Sanitarium_WL ("$data/categories", 'categories');
%category=$obj->get_data($in{'cat_id'});
unless ($in{'del_cat'}){
	#Build category Info
	$html=&category_info($in{'cat_id'}, $in{'cat_name'}, $in{'cat_description'}, $in{'cat_keywords'}, $in{'template'});
	$html .= qq~
	$msg{'want_del'}
	<p>
	<a href="$script_admin?cat_id=$in{'cat_id'}&delete_category=1&del_cat=1"><b>$msg{'yes_del_cat'}</b></a>
	~;
	&head;
	&table($msg{'att'}, $html);
	&foot;
}
else {
	
	$obj->delete_data($in{'cat_id'});#Delete Category... bay-bay, babe!
	$obj=0;
	#Now Delete categories'articles from index
	$obj= new Sanitarium_WL ("$data/$in{'cat_id'}", 'index');
	@del_keys=$obj->get_keys();
	$obj=0;
	#Delete articles from index DB:
	$obj= new Sanitarium_WL ("$data/index", 'index');
	$obj->mass_delete(@del_keys);
	$obj=0;
#######################################	
	#DELETING FROM INDEX ALL Articles!
	if ($use_search){
		foreach my $key(@del_keys){
			&delete_from_index_all($key);
		}
	}	
######################################	
	#Delete Categories DB:
	unlink ("$data/$in{'cat_id'}.dat")||&WLerr("Can not delete file $data/$in{'cat_id'}.dat, reason: $!"); #Delete category database :0 What you think about archiving???
	unlink ("$data/$in{'cat_id'}.lock") if (-e "$data/$in{'cat_id'}.lock");
	opendir (CATDEL, "$data/$in{'cat_id'}")||&WLerr("Can not open dir: $data/$in{'cat_id'}, reason: $!");
	#delete all files from directory
	while (my $file=readdir(CATDEL)){
		if ($file=~/\w/){
		unlink("$data/$in{'cat_id'}/$file")||&WLerr("Can not delete file: $data/$in{'cat_id'}/$file, reason: $!");
		if ($file=~/\.dat/){ 
			$file=~s/\.dat/.txt/; 
			unlink("$data/comments/$file") if (-e "$data/comments/$file");
		}
		}
	}
	closedir(CATDEL) or &WLerr("Can not close directory: $data/$in{'cat_id'}, reason: $!");	
	#delete cat dir:
	rmdir("$data/$in{'cat_id'}") or &WLerr("Can not delete category, reason: $!");

	#Delete Categories HTML
	opendir (CATDEL, "$public_dir/$in{'cat_id'}") or &WLerr("Can not open dir: $public_dir/$in{'cat_id'}, reason: $!");
	#delete all files from cat directory
	while (my $file=readdir(CATDEL)){
		if (defined $file && $file=~/\w/){
		unlink("$public_dir/$in{'cat_id'}/$file") or &WLerr("Can not delete file: $public_dir/$in{'cat_id'}/$file, reason: $!");}
	}
	closedir(CATDEL)||&WLerr("Can not close directory: $public_dir/$in{'cat_id'}, reason: $!");	
	#delete forum dir:
	rmdir("$public_dir/$in{'cat_id'}") or &WLerr("Can not delete directory $public_dir/$in{'cat_id'}, reason: $!");

	#Update Cache Info:
	#&rebuild_caches;
	
	#Build category Info:
	$html=&category_info($in{'cat_id'}, $in{'cat_name'}, $in{'cat_description'}, $in{'cat_keywords'}, $in{'template'});
	$html .=$msg{'cat_del_end'};

	&head;
	&table($msg{'cat_del'}, $html);
	&foot;
}
}

sub view_category {
#---------------------------------------------------------------------	
my ($obj, $html, @keys, %category, %cat);
#my %authors=&authors_list;
$obj= new Sanitarium_WL("$data/categories", 'categories');
%category= $obj->get_nn_recs('all');
if ($in{'cat_id'}){
push(@keys, $in{'cat_id'});
%cat=$obj->unpack_to_hash($category{$in{'cat_id'}});
}
else {
@keys = sort {$a <=> $b} keys %category;
}
&head;

#'categories'  =>['cat_name', 'cat_description', 'cat_keywords', 'template'],
unless ($in{'page'}){
foreach my $key (@keys){
	%cat=$obj->unpack_to_hash($category{$key}) unless($in{'cat_id'});
	$html =&category_info($key, $cat{'cat_name'}, $cat{'cat_description'}, $cat{'cat_keywords'}, $cat{'template'});
	$html .= qq~<br>
<a href="$script_admin?cat_id=$key&modify_category=1">:$msg{'modify'}</a>
<a href="$script_admin?cat_id=$key&view_category=1"> :$msg{'view'}</a>
<a href="$script_admin?cat_id=$key&rebuild_cat=1"> :$msg{'rebuild'}</a>
<a href="$script_admin?cat_id=$key&delete_category=1"> :$msg{'delete'}</a>
~;
	&table("$msg{'cat'} - $cat{'cat_name'}", $html);
}
}
#Articles in Category
if ($in{'cat_id'}){
#articles per page:
my $mes_per_page=15;

$obj= new Sanitarium_WL("$data/$in{'cat_id'}", 'index');
my $num_recs=$obj->get_num_recs();

#Number pages
my $how_pages = int ($num_recs/$mes_per_page);
++$how_pages if ($how_pages*$mes_per_page != $num_recs);

#Build page index
$in{'page'}||=0;
my $pages;
for (my $i =1; $i<=$how_pages; $i++){ 
	my $num=($i-1);
	#....HTML
	if ($num != $in{'page'}){$pages .= qq~ <a href="$script_admin?cat_id=$in{'cat_id'}&page=$num&view_category=1"> $i|</a>~;}
	else {$pages .= qq~ $i~;}
}
$pages||= '1';

#

my %data=$obj->get_nn_recs($mes_per_page, $in{'page'});#15 topiks per page
my @articles= sort {$b<=>$a} keys %data;
my %art_data;

#Build List of Articles:
print qq~ <DIV class="news">~;
foreach my $article(@articles){
	%art_data= $obj->unpack_to_hash($data{$article});
#	if ($art_data{'author'}=~/\d+auth/){
#		$art_data{'author'}=$authors{$art_data{'author'}};
#	}	
	print qq~
	[ id:$article ] <b>$art_data{'title'}</b><br>
	<sub>$msg{'Date'}: $art_data{'date'} $msg{'page'}: $art_data{'pages'}</sub><DIV style="background-color:#f0f0f0"> <a href="$script_admin?cat_id=$in{'cat_id'}\&id=$article\&modify=1" class="news">:$msg{'modify'}: </a> 
	<a href="$script_admin?cat_id=$in{'cat_id'}&id=$article&delete_article=1" class="news">:$msg{'delete'}: </a><a href="$script_admin?cat_id=$in{'cat_id'}\&id=$article\&article_rebuild=1" class="news">:$msg{'rebuild'}:</a> 
	<a href="$comadmin_cgi_url?cat_id=$in{'cat_id'}&id=$article&article_coms=1" class="news">:$msg{'view_coms'}:</a> 
	</DIV><br>~;

}
$obj=0;
print qq~</DIV><br>
<DIV class="td0"> \&nbsp;$msg{'Pages'}: $pages</DIV> ~;
#
}
#End Articles	
&foot;
}

sub category_info {
#-------------------------------------------------------------
return qq~
    $msg{'info'}:
	<br>
	<li> <b>$msg{'Category ID'}:</b> $_[0]
	<li> <b>$msg{'cat_path'}:</b> <a href="$public_url/$_[0]" target=_blank>$public_url/$_[0]</a>
	<li> <b>$msg{'cat_name'}:</b> $_[1]
	<li> <b>$msg{'cat_desc'}:</b><i> $_[2] </i>
	<li> <b>$msg{'cat_keywords'}:</b><i> $_[3] </i>
	<li> <b>$msg{'template'}:</b> $_[4]
	<br>
	~;
}

sub category_list {
#----------------------------------------------------------
my ($obj, @keys, @list, %category);

$obj = new Sanitarium_WL("$data/categories", 'categories');
%category = $obj->get_nn_recs('all');
#categories=>['cat_name', 'cat_description', 'cat_keywords', 'template'],
@keys= keys %category;
foreach my $cat(@keys){
	my %cat=$obj->unpack_to_hash($category{$cat});
	push(@list,$cat,$cat{'cat_name'});
}
$obj=0;
return @list;
}	


#......#ARTICLES
################

sub add_article {
#--------------------------------------------------------------
my ($obj, $html,$value, $name, $id, $modify_old, $page, @keys, %art_dump, %article, %first);
$modify_old=shift;
$modify_old||=0;
#$in{'page'}||=shift;
#$in{'cat_id'}||=shift
#$in{'entry'}||=shift;
$page=$in{'page'}||1;
if ($in{'cat_id'}&&$in{'id'}){
	#CREATE OBJECT
	$obj = new Sanitarium_WL ("$data/$in{'cat_id'}/$in{'id'}", 'article');
	%art_dump = $obj->get_nn_recs('all');
	@keys= sort {$a <=> $b} keys %art_dump;
	%article=$obj->unpack_to_hash($art_dump{$keys[$page-1]}) if $in{'page'};
	%first=$obj->unpack_to_hash($art_dump{$keys[0]});
	$first{'id'}=$in{'id'};
	undef %art_dump;
	#DESTROY
	$obj=0;
	$value='Modify Page!';
	$name='save_mod_article';#don't change this value
	
	#IMG EMOTICONS TO SYMBOLS:
	if ($use_emoticons){
		$article{'preview'}=&emoticons_to_symbol($article{'preview'}) if $article{'preview'};
		$article{'content'}=&emoticons_to_symbol($article{'content'}) if $article{'content'};
		$first{'preview'}=&emoticons_to_symbol($first{'preview'});
	}	
	#HTML to form: 
	if ($article{'related'}=~/<!--([\d,]+)-->/){$article{'related'}=$1;}
	elsif ($first{'related'}=~/<!--([\d,]+)-->/){$first{'related'}=$1;}
	$article{'preview'}=&text_to_form($article{'preview'}) if $article{'preview'};
	$article{'content'}=&text_to_form($article{'content'}) if $article{'content'};
	$first{'preview'}=&text_to_form($first{'preview'}) if $first{'preview'};
	
}
else {
	$value='Post!';
	$name='save_article';#don't change this value
	$obj= new Sanitarium_WL("$data/id", 'none');
	$id=$obj->get_id();
	$obj=0;

}	
#if ($modify_old eq 'next'){undef $modify_old;}
#Print Page
$id||=$in{'id'};
&head;
print qq~
<form action="$script_admin" METHOD="POST" name=frm1 ID="frm1">
<input type=hidden name="num" value="$page">
<input type=hidden name="id" value="$id">
~;
#About Page Number
if (($modify_old)&&($modify_old != 666)&&($use_search)){
	&table($msg{'indexing_title'}, qq~
	<input type=CHECKBOX name=indexing value=1 CHECKED> $msg{'index_y'}<br>$msg{'index_y_n'}
	~);
}
if ($modify_old == 666){&table("Add Page", $msg{'add_page'});}
else {&table("$msg{'page'} $page", $msg{'input_page'}." $page");}
print qq~<input type=hidden name="modify_old" value="$modify_old">~ if $modify_old;
#If modify, but not first page:
if ($first{'pages'}||($modify_old == 666)){
#Not modify: cat_id, pages, num, id, author, date:
	print qq~<input type=hidden name="cat_id" value="$first{'cat_id'}">
	<input type=hidden name="pages" value="$first{'pages'}">
	<input type=hidden name="date" value="$first{'date'}">
	~;
 	if ($first{'author'}=~/,,,/){
 	#Coding unregistered authors data for hidden input field
 		$first{'author'}=~s/"/|34;/g;
		$first{'author'}=~s/'/|44;/g;
		$first{'author'}=~s/</|60;/g;
		$first{'author'}=~s/>/|62;/g;
	}
 	print qq~<input type=hidden name="author" value="$first{'author'}">~;
}
#if modify first page, than not change id!
elsif ($first{'id'}){print qq~ <input type=hidden name="cat_id" value="$first{'cat_id'}">~;}

#IF CREATE FIRST PAGE:
if (!$in{'id'}){
#........AUTHOR
$html =&js_drop_list('authorid','author',$first{'author'},&authors_list);
$html .= "<br>$msg{'select_author'}";
		&table($msg{'Author'}.':', $html);
#........SELECT CATEGORY
		&table($msg{'select_cat'}.':', &drop_list('cat_id',$first{'cat_id'}, &category_list));
#........PAGES
		&table($msg{'how_pages'}.':', &input_form('pages', 2, 2, 1));
}		
else {
	$html= qq~$msg{'how_pages'}: $first{'pages'}~;
	&table($msg{'how_pages'}.':', $html);
	}

#Print input fields:
if ($modify_old == 666){
	$article{'content'}='';
	&table($msg{'new_page_num'}.':', &drop_list('add_page', ($first{'pages'}+1), &pages_list($first{'pages'}+1)));
}
#FOR ALL:
&table($msg{'Title'}.':', &input_form('title', 70, 150, ($article{'title'}||$first{'title'})));
&table($msg{'Preview'}.'/Meta Description:', &textarea('preview', 60, 5, ($article{'preview'}||$first{'preview'})));
&table($msg{'keywords'}.':', &textarea('keywords', 60, 5, ($article{'keywords'}||$first{'keywords'})));
$html='';
if ($qhtml||$fozzy){
	$html=qq~
	<script language="JavaScript1.2">
	<!-- 
	~;
	if ($fozzy){$html .= $msg{'fozzy'};}
	$html .= qq~
	function addText(text)
	{
	 document.frm1.content.value = document.frm1.content.value + text + "\\n";
	}
	// -->
	</script>
	<table border=0 cellpadding=2 cellspacing=0 class="td1">
	<tr>
	<td><a href="JavaScript:addText('<B></B>')"><img src="$img_url/b.gif" alt="B" width=20 height=20 border=0 vspace=0 hspace=0></a></td>
	<td><a href="JavaScript:addText('<I></I>')"><img src="$img_url/i.gif" alt="I" width=20 height=20 border=0 vspace=0 hspace=0></a></td>
	<td><a href="JavaScript:addText('<P>')"><img src="$img_url/p.gif" alt="P" width=20 height=20 border=0 vspace=0 hspace=0></a></td>
	<td><a href="JavaScript:addText('<br>')"><img src="$img_url/br.gif" alt="BR" width=20 height=20 border=0 vspace=0 hspace=0></a></td>
	<td><a href="JavaScript:addText('<img src=\\'\\' width=\\'\\' height=\\'\\' alt=\\'\\' align=\\'\\'>')"><img src="$img_url/img.gif" alt="img" width=20 height=20 border=0 vspace=0 hspace=0></a></td>
	<td><a href="JavaScript:addText('<a href=\\'\\' target=_blank></a>')"><img src="$img_url/a.gif" alt="A" width=20 height=20 border=0 vspace=0 hspace=0></a></td>
	<td><a href="JavaScript:addText('<!--MY CODE-->\\n\\n<!--END CODE-->')"><img src="$img_url/code.gif" alt="CODE" width=20 height=20 border=0 vspace=0 hspace=0></a></td>  
	<td><a href="JavaScript:addText('<li>')"><img src="$img_url/li.gif" alt="li" width=20 height=20 border=0 vspace=0 hspace=0></a></td>
	<td><a href="JavaScript:addText(' :) ')"><img src="$img_url/smile.gif" alt=":)" width=15 height=15 border=0 vspace=0 hspace=0></a></td>
	<td><a href="JavaScript:addText(' 8) ')"><img src="$img_url/cool.gif" alt="8)" width=15 height=15 border=0 vspace=0 hspace=0></a></td>
	<td><a href="JavaScript:addText(' :( ')"><img src="$img_url/sad.gif" alt=":(" width=15 height=15 border=0 vspace=0 hspace=0></a></td>
	</tr></table>
	~;
}
	$html .=&textarea('content', 60, 25, $article{'content'});
if ($fozzy){$html .=$msg{'fozzy_html'};}
&table($msg{'content'}.':', $html);
$html='';
&table($msg{'related'}.':', (&input_form('related', 70, 70, ($article{'related'}||$first{'related'}))).$msg{'about_related'});
print qq~
<input type=SUBMIT name="$name" value="$value" class="form1"></form>
~;
&foot;
#end sub
}	

sub save_article {
#--------------------------------------------------------------
my ($obj, $id, @check, @err);
#article  =>['cat_id', 'title', 'date', 'author', 'preview', 'content', 'keywords', 'num', 'pages'],);
@check=('cat_id', 'title', 'content',  'num', 'pages');
foreach my $check(@check){
	if (!$in{$check}){push(@err, $check);}
}
if (@err){&msg("$msg{'not_defined'} @err!<br>$msg{'back'}");}
unless($in{'date'}){$in{'date'}=&get_time();}
#IF MODIFY:
if ($in{'indexing'}&&$use_search){&delete_page_from_index($in{'cat_id'}, $in{'id'}, $in{'num'});}
#IF ADD PAGE to old article
if ($in{'add_page'}) {
	&delete_from_index_all if $use_search;
	$in{'num'}=$in{'add_page'};#update some %in data
	$in{'pages'}++;
	
	$obj= new Sanitarium_WL("$data/$in{'cat_id'}/$in{'id'}", 'article');
	$obj->add_page($in{'id'}, $in{'add_page'});#rebuild article DB
	$obj=0;
	
	foreach my $db_index ($in{'cat_id'}, 'index'){
		$obj=new Sanitarium_WL("$data/$db_index", 'index');
		$obj->modify_fields($in{'id'}, 'pages', 'pages++');#Update number of pages in indexes
		$obj=0;
	}
	
#END IF PAGE
}
#RELATED
if ($in{'related'}){
	$in{'related'} =~ s/[^\d,]//g;
	my @related=split(/,/,$in{'related'});
	$in{'related'}= qq~<!--$in{'related'}-->~;
	&load_cfg;
	$in{'related'} .= $builder->related_links($in{'cat_id'},@related);
	$builder=0;	
}	
#AUTHOR
unless($in{'author'}||$in{'radiom'}){&msg("$msg{'not_defined'} - author!<br>$msg{'back'}");}
if ($in{'radiom'}){
	if ($in{'radiom'} eq 'my'){
	unless($in{'authorid'}){&msg("$msg{'not_defined'} - author!<br>$msg{'back'}");}
	$in{'author'}=$in{'authorid'};
	}
	else {$in{'author'}=join(",,,", $in{'authname'},$in{'authmail'},$in{'authsignature'},$in{'authfoto'},$in{'authwww'});}
}
elsif ($in{'author'}=~/,,,/){
#Encoding unregistered authors data from hidden field to normal html view
	$in{'author'}=~s/\|34;/"/g;
	$in{'author'}=~s/\|44;/'/g;
	$in{'author'}=~s/\|60;/</g;
	$in{'author'}=~s/\|62;/>/g;
}
#CONTENT
my $content=&parse_article($in{'content'});
$in{'content'}=0;#DESTROY!

#PREVIEW
$in{'preview'}||= substr($content, 0, 180);#180 simbols in preview by default!
my $preview=&parse_article($in{'preview'});
$in{'preview'}=0;#DESTROY!

$id=$in{'id'};

#NOW WRITE INTO ARTICLE DB
#'article'=>['cat_id', 'title', 'date', 'author', 'preview', 'content', 'keywords', 'num', 'pages', 'related']
$obj= new Sanitarium_WL("$data/$in{'cat_id'}/$id", 'article');
	  $obj->add_entry($in{'num'},
	                  $in{'cat_id'},
	                  $in{'title'},
	                  $in{'date'},
	                  $in{'author'},
	                  $preview,
	                  $content,
	                  $in{'keywords'},
	                  $in{'num'},
	                  $in{'pages'},
	                  $in{'related'});

$in{'id'}=$id;
#IF MODIFY ARTICLE
if ($in{'modify_old'}&&($in{'num'}!=1)){&mod_article;}
#IF END - UPDATE INDEX!
elsif (($in{'num'} == $in{'pages'})||($in{'modify_old'})){
	if ($in{'modify_old'}){
	&indexing_page($in{'cat_id'}, $in{'id'}, $in{'num'}) if (($in{'modify_old'}!=666)&&($use_search)&&$in{'indexing'});
	&end_article_input;
	}#If Modify First Article Page 
	else {&end_article_input;}#If add new article
	}
#IF NEXT PAGE
else {
	$in{'page'}=($in{'num'}+1);
	&add_article;
	#('next', ($in{'num'}+1), $in{'cat_id'}, $id)
}
#end sub
}	


sub mod_by_id {
#-------------------------------------------------------------
my $html;
if ($in{'id'}){
	my $obj=new Sanitarium_WL("$data/index", 'index');	
	my %art=$obj->check_and_get($in{'id'});
	$obj=0;
	if ($art{'cat_id'}){
		%in=%art;
		&mod_article($in{'id'});
		exit;
		}
	else {$html = qq~<b>ID:$in{'id'}</b> $msg{'not_id'}<p>~;}
}	
&head;
#Search by ID
$html .= qq~<form action="$script_admin" METHOD="POST">$msg{'by_id'}<br>~;
$html .=&input_form('id', 10, 10, '');
$html .= qq~<input type=SUBMIT name="search_id" value="Find!" class="form1"></form>~;
&table("Input ID", $html);

#Search by Category	
$html = qq~<form action="$script_admin" METHOD="POST">~;
$html .=$msg{'by_cat'};
$html .= &drop_list('cat_id','', &category_list);
$html .= qq~<input type=SUBMIT name="view_category" value="View!" class="form1"></form>~;
&table('Select Category', $html);
&foot;
	
#end sub	
}	


sub mod_article {
#-------------------------------------------------------------	
my ($obj, $modify, $html, @keys, %art_dump, %article, %authors);
my $id=shift;
my $cat_id=shift;
$id||=$in{'id'};
$cat_id||=$in{'cat_id'};
&head;

$obj= new Sanitarium_WL("$data/$cat_id/$id", 'article');
%art_dump = $obj->get_nn_recs('all');
#Now Print short article info
my %art=$obj->unpack_to_hash($art_dump{1});#Get info from first page

$art{'author'}=&get_author_name($art{'author'});
	
$html= qq~
<li> <b>$msg{'Article_ID'}:</b> $id
<li> <b>$msg{'Title'}:</b> $art{'title'}
<li> <b>$msg{'Date'}:</b> $art{'date'}
<li> <b>$msg{'Author'}:</b> $art{'author'}
<li> <b>$msg{'how_pages'}:</b> $art{'pages'}
<li> <b>$msg{'Preview'}:</b> $art{'preview'}
~;
&table($msg{'info'}, $html);

@keys= sort {$a <=> $b} keys %art_dump;

#Article Options
$html = qq~
<DIV class="news">
<li> <a href="$script_admin?article_rebuild=1&cat_id=$art{'cat_id'}&id=$id" class="news"><b>$msg{'a_pub'}</b></a>  $msg{'a_pub_desc'}
<li> <a href="$script_admin?mod_art_options=1&cat_id=$art{'cat_id'}&id=$id&page=1" class="news"><b>$msg{'a_mod'}</b></a>  $msg{'a_mod_desc'}
<li> <a href="$script_admin?add_page=1&cat_id=$art{'cat_id'}&id=$id&page=1" class="news"><b>$msg{'add_page'}</b></a> $msg{'add_page_desc'}
<li> <a href="$comadmin_cgi_url?cat_id=$art{'cat_id'}&id=$id\&article_coms=1" class="news"><b>$msg{'view_art_coms'}</b></a> 
~;
if ($use_search){
	$html .= qq~
<li> <a href="$script_admin?index_article=1&cat_id=$art{'cat_id'}&id=$id" class="news"><b>$msg{'index_article'}</b></a> $msg{'index_article_desc'}
<li> <a href="$script_admin?delete_from_index=1&cat_id=$art{'cat_id'}&id=$id" class="news"><b>$msg{'a_delete_index'}</b></a> $msg{'a_delete_index_desc'}
	~;
}
$html .= qq~	
<li> <a href="$script_admin?delete_article=1&cat_id=$art{'cat_id'}&id=$id" class="news"><b>$msg{'a_delete'}</b></a> $msg{'a_delete_desc'}
</DIV>
~;
&table($msg{'a_t_opt'}.':', $html);

$html= qq~<ol>~;
#Build Article Index
foreach my $key(@keys){
%article = $obj->unpack_to_hash($art_dump{$key});
$html .= qq~
<li> [ $msg{'page'}:$article{'num'} ] <a href="$view_cgi_url?cat_id=$article{'cat_id'}&id=$id&page=$key" target=_blank>
 <b>$article{'title'}</b></a><br>
 :<a href="$view_cgi_url?cat_id=$article{'cat_id'}&id=$id&page=$key" target=_blank>$msg{'view'}</a> 
 :<a href="$script_admin?modify_article=1&cat_id=$article{'cat_id'}&id=$id&page=$key">$msg{'modify'}</a> 
 :<a href="$script_admin?delete_page=1&cat_id=$article{'cat_id'}&id=$id&page=$key">$msg{'delete'}</a>
 <br><br>~;
  }
 undef %art_dump;
$html .= qq~</ol>~;
&table("$msg{'Pages'}:", $html);
&foot;
#end sub
}	


sub mod_article_options {
#-------------------------------------------------------
my ($obj, $html, $author, %art);
if (!$in{'save_new_options'}){
$obj= new Sanitarium_WL("$data/$in{'cat_id'}", 'index');
%art=$obj->get_data($in{'id'});
$obj=0;
$author=$art{'author'};
	$art{'author'}=&get_author_name($art{'author'});

&head;
$html= qq~
<li> <b>$msg{'Article_ID'}:</b> $in{'id'}
<li> <b>$msg{'Title'}:</b> $art{'title'}
<li> <b>$msg{'Date'}:</b> $art{'date'}
<li> <b>$msg{'Author'}:</b> $art{'author'}
<li> <b>$msg{'how_pages'}:</b> $art{'pages'}
~;
&table($msg{'info'}, $html);

print qq~
<form action="$script_admin" METHOD="POST" name=frm1>
<input type=hidden name="cat_id" value="$in{'cat_id'}">
<input type=hidden name="id" value="$in{'id'}">
<input type=hidden name="pages" value="$art{'pages'}">
~;
&table($msg{'select_cat'}.':', &drop_list('new_cat_id',$in{'cat_id'}, &category_list));
$html =&js_drop_list('author_id','author',$author,&authors_list);
$html .=$msg{'select_author'};
		&table($msg{'Author'}.':', $html);
&table($msg{'status'}.':', &drop_list('status',$art{'status'}, 'ok', $msg{'open'}, 'close', $msg{'close'}));
print qq~
<input type=SUBMIT name="save_new_options" value="Change!" class="form1"></form>
~;
&foot;
}
else {
	#AUTHORS
	if ($in{'radiom'} eq 'my'){$in{'author'}=$in{'authorid'};}
	else {$in{'author'}=join(",,,", $in{'authname'},$in{'authmail'},$in{'authsignature'},$in{'authfoto'},$in{'authwww'});}
	
	#IF NEW CATEGORY
	unless ($in{'cat_id'} == $in{'new_cat_id'}){
		rename("$data/$in{'cat_id'}/$in{'id'}.dat", "$data/$in{'new_cat_id'}/$in{'id'}.dat")||&WLerr("Can't rename $data/$in{'cat_id'}/$in{'id'}.dat to $data/$in{'new_cat_id'}/$in{'id'}.dat REASON: $!");
	    unlink("$data/$in{'cat_id'}/$in{'id'}.lock") if (-e "$data/$in{'cat_id'}/$in{'id'}.lock");

		foreach my $pg (1..$in{'pages'}){
			if (-e "$public_dir/$in{'cat_id'}/$in{'id'}"."_"."$pg.$ext"){
				rename("$public_dir/$in{'cat_id'}/$in{'id'}"."_"."$pg.$ext", "$public_dir/$in{'new_cat_id'}/$in{'id'}"."_"."$pg.$ext")||&WLerr("Can't rename $data/$in{'cat_id'}/$in{'id'} to $data/$in{'new_cat_id'}/$in{'id'} REASON: $!");
			}
		}	
		$obj= new Sanitarium_WL("$data/$in{'cat_id'}", 'index');
		my %article=$obj->get_data($in{'id'});
		$obj->delete_data($in{'id'});
		$obj=0;
		$obj= new Sanitarium_WL("$data/$in{'new_cat_id'}", 'index');
		$obj->write_data($in{'id'},
                     $article{'title'},
                     $article{'preview'},
                     $in{'new_cat_id'},
                     $in{'author'},
                     $in{'id'},
                     $article{'date'},
                     $article{'pages'},
                     $in{'status'});
        $obj=0;  
    &rebuild_category($in{'cat_id'});       
	}	
	else {
		$obj= new Sanitarium_WL("$data/$in{'cat_id'}", 'index');
		$obj->modify_fields($in{'id'}, 'author', $in{'author'}, 'status', $in{'status'});
		$obj=0;	
	}
	$obj= new Sanitarium_WL("$data/$in{'new_cat_id'}/$in{'id'}", 'article');
	$obj->modify_all_recs('cat_id', $in{'new_cat_id'}, 'author', $in{'author'});
	$obj=0;
	$obj= new Sanitarium_WL("$data/index", 'index');
	$obj->modify_fields($in{'id'}, 'cat_id',$in{'new_cat_id'}, 'author', $in{'author'}, 'status', $in{'status'});
	$obj=0;	
	&rebuild_category($in{'cat_id'});
	&index_print('index');
	$in{'cat_id'}=$in{'new_cat_id'};
	&article_rebuild;
	&mod_article($in{'id'},$in{'new_cat_id'});
}
#end sub
}	
	

sub end_article_input {
#-------------------------------------------------------	
#'article' =>['cat_id', 'title', 'date', 'author', 'preview', 'content', 'keywords', 'num', 'pages', 'related'],);
my ($obj, $modify, %article);
my $id=$in{'id'};
$modify=$in{'modify_old'}||shift;

$obj= new Sanitarium_WL("$data/$in{'cat_id'}/$id", 'article');
%article=$obj->get_data(1);
undef $article{'content'};#now its not need
undef $article{'keywords'};
undef $article{'related'};
$article{'status'}=($in{'status'}||'ok');
$obj=0;
#UPDATE CATEGORY INDEX
#'index' =>['title', 'preview', 'cat_id', 'author', 'id', 'date', 'pages', 'status'],
my @db_index=($article{'cat_id'}, 'index');
foreach my $db_index (@db_index){
	$obj= new Sanitarium_WL("$data/$db_index", 'index');
	#IF MODIFY
	if ($modify){
   	$obj->modify_data($id,
                     $article{'title'},
                     $article{'preview'},
                     $article{'cat_id'},
                     $article{'author'},
                     $id,
                     $article{'date'},
                     $article{'pages'},
                     $article{'status'});
 	}
 	#IF NEW
 	else {$obj->write_data($id,
                     $article{'title'},
                     $article{'preview'},
                     $article{'cat_id'},
                     $article{'author'},
                     $id,
                     $article{'date'},
                     $article{'pages'},
                     $article{'status'});
  	}
  $obj=0;
  }	
  %in=%article;	                   
  &mod_article($id);               
#end sub
}

sub delete_article_from_index {
#-------------------------------------------------------------
unless ($use_search){return 0;}
my ($obj, @ids);
my $option=shift;
if (!$in{'delete_from_index_y'}){
	&head;
	my $html= qq~ $msg{'a_q_del_index'} <br>
	<a href="$script_admin?delete_from_index_y=1&cat_id=$in{'cat_id'}&id=$in{'id'}"><b>$msg{'a_delete_index'}</b></a>
	~; 
	&table('Are you sure?', $html);
	&foot;
}
else {
	&delete_from_index_all;
	&head;
	my $html= $msg{'a_del_index'}; 
	&table($msg{'a_t_del'}, $html);
	&foot;

}	
}	


sub delete_article {
#--------------------------------------------------------------
my ($obj, @ids);
if (!$in{'del_art_now'}){
	&head;
	my $html= qq~ $msg{'a_q_del'} <br>
	<a href="$script_admin?delete_article=1&cat_id=$in{'cat_id'}&id=$in{'id'}&del_art_now=1"><b>Yes, delete this article!</b></a>
	~; 
	&table('Are you sure?', $html);
	&foot;
}
else {
	if (-e "$data/$in{'cat_id'}/$in{'id'}.dat"){
		$obj= new Sanitarium_WL ("$data/$in{'cat_id'}/$in{'id'}");
		@ids=$obj->get_keys();
		$obj=0;
		&delete_from_index_all if $use_search;#DELETE FROM SEARCH INDEX
		#DELETE .DAT File with article's db
		unlink("$data/$in{'cat_id'}/$in{'id'}.dat")||&WLerr("Can not delete $data/$in{'cat_id'}/$in{'id'}.dat, reason: $!");
		#..delete lock file
		unlink("$data/$in{'cat_id'}/$in{'id'}.lock") if (-e "$data/$in{'cat_id'}/$in{'id'}.lock");
		#..delete comments
		unlink("$data/comments/$in{'id'}.txt") if (-e "$data/comments/$in{'id'}.txt");

	}
		foreach my $db_index ($in{'cat_id'}, 'index'){
		$obj=new Sanitarium_WL("$data/$db_index", 'index');
		$obj->delete_data($in{'id'});
		$obj=0;
	}
	#Delete *.$ext pages (ex., *.html)
	$obj= new Sanitarium_WL ("$data/categories", 'categories');
	my %category=$obj->get_data($in{'cat_id'});
	$obj=0;
	foreach my $id_page(@ids){
		if (-e "$public_dir/$in{'cat_id'}/$in{'id'}".'_'."$id_page.$ext"){
		unlink("$public_dir/$in{'cat_id'}/$in{'id'}".'_'."$id_page.$ext")||&WLerr("Can't delete $public_dir/$category{'cat_id'}/$in{'id'}".'_'."$id_page.$ext , reason: $!");
		}
	}
	&head;
	my $html= $msg{'a_del'}; 
	&table($msg{'a_t_del'}, $html);
	&foot;
}
#end sub
}	


sub delete_page {
#----------------------------------------------------------
my ($obj, $html, $author, %page_info);
$obj = new Sanitarium_WL("$data/$in{'cat_id'}/$in{'id'}", 'article');
if (!$in{'del_this_page'}){
	%page_info = $obj->get_data($in{'page'});
	$author=&get_author_name($page_info{'author'});
	undef $page_info{'content'};#clean memory
	undef $page_info{'keywords'};#clean memory
	undef $page_info{'related'};#clean memory
	$html = qq~
	<b>$msg{'dalete_it'}</b>
	<li><b> $msg{'Page_Num'}:</b> $page_info{'num'}
	<li><b> $msg{'Title'}:</b> $page_info{'title'}
	<li><b> $msg{'Article_ID'}:</b> $in{'id'}
	<li><b> $msg{'Author'}:</b> $author
	<li><b> $msg{'Category ID'}:</b> $page_info{'cat_id'}
	<li><b> $msg{'Date'}:</b> $page_info{'date'}
	<li><b> $msg{'Preview'}:</b> $page_info{'preview'}
	<p>
	<a href="$script_admin?delete_page=1&cat_id=$page_info{'cat_id'}&id=$in{'id'}&page=$page_info{'num'}&del_this_page=1"><b>$msg{'yes_del'}</b></a>
	~;
	&head;
	&table($msg{'you_sure'}, $html);	
	&foot;
}	
else {
	&delete_from_index_all if $use_search;
	$obj->delete_page($in{'id'}, $in{'page'});
	$obj=0;
	foreach my $db_index ($in{'cat_id'}, 'index'){
		$obj=new Sanitarium_WL($data."/".$db_index, 'index');
		$obj->modify_fields($in{'id'}, 'pages', 'pages--');#Update number of pages in indexes
		$obj=0;
	}
	#GET CATEGORY INFO:
	$obj= new Sanitarium_WL ("$data/categories", 'categories');
	my %category=$obj->get_data($in{'cat_id'});
	$obj=0;
	#Delete *.$ext version of page
	if (-e "$public_dir/$category{'cat_id'}/".$in{'id'}."_".$in{'page'}.$ext){
		unlink ("$public_dir/$category{'cat_id'}/".$in{'id'}."_".$in{'page'}.$ext)||&WLerr("Can't delete $public_dir/$category{'cat_id'}/$in{'id'}".'_'."$in{'page'}.$ext , reason: $!");
	}
	
	&end_article_input(1);	
}

#end sub
}	

sub pages_list {
#---------------------------------------------------------
my %nums=();
%nums=map{$_=>$_}(1..$_[0]);
#foreach my $num(1..$_[0]){
#		$nums{$num}=$num;
#}
return %nums;
}


#........#MISC
##############

sub WLopen {
#--------------------------------------------------------------
my ($filename, $my_flock);
$filename = shift;
$my_flock = shift;
$filename =~ s/[^\w\\\/><\.\-:]//g;
$my_flock =~s/(\d)+/$1/g;
$my_flock =~s/[^128]/1/g;
open ('TEXT', $filename)||&WLerr("Could not open $filename, reason:$!");
if ($use_flock){flock(TEXT,$my_flock) or &WLerr("Could not flock $filename, reason:$!");}
}


sub get_time {
#-------------------------------------------------------------
my $time=shift;
$time||=time();
if ($GMT){$time +=$GMT*3600;}
my(@MON)= split(/,/, $msg{'MON'});
my(@WDAY) = split(/,/, $msg{'WDAY'}); 

my($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime($time);
$year += 1900;
if ($time_view == 1){ return sprintf("%02d/%02d/%04d",$mday,($mon+1),$year);}# dd/mm/yyyy
elsif ($time_view == 2){ return sprintf("%02d %s %04d", $mday,$MON[$mon],$year);}# dd MON yyyy
elsif ($time_view == 3){return sprintf("%s, %02d %s. %04d",$WDAY[$wday],$mday,$MON[$mon],$year);}#WEEKDAY DAY MON yyyy
elsif ($time_view == 4){return sprintf("%s, %02d %s %04d %02d:%02d:%02d",$WDAY[$wday],$mday,$MON[$mon],$year,$hour,$min,$sec);}#WDAY DAY MON yyyy hour:min:sec
elsif ($time_view == 5){return sprintf("%02d.%02d.%04d",$mday,($mon+1),$year);}#dd.mm.yyyy
elsif ($time_view == 6){return sprintf("%02d.%02d.%04d",($mon+1),$mday,$year);}#mm.dd.yyyy
else {return sprintf("%02d/%02d/%04d",($mon+1),$mday,$year);}#mm/dd/yyyy
}	

#........#HTML
##############


sub head {
#--------------------------------------------------------------
&print_header;
&head_html;
print qq~
<table cellpadding=0 cellspacing=0 border=0  width="100%" height="100%">
<tr><td valign=top width=200 class="td1" rowspan=2>
<table cellpadding=0 cellspacing=5 border=0 width=200>
<tr><td valign=top>
<DIV class="red">
&raquo; $msg{'2'}
<li><a href="$script_admin?new_article=1">$msg{'3'}</a>
<li><a href="$script_admin?search_view=1">$msg{'4'}</a>
<p>

&raquo; $msg{'6'}
<li><a href="$script_admin?new_cat=1">$msg{'7'}</a>
<li><a href="$script_admin?view_category=1">$msg{'4'}</a>
<p>

&raquo; $msg{'14'}
<li><a href="$upload_url" target="newWindow"  onclick="window.open('$upload_url','newWindow','toolbar=yes, location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,width=300,height=320'); return false">$msg{'menu_upload'}</a>
<li><a href="$script_admin?list_files=1" target="newWindow"  onclick="window.open('$script_admin?list_files=1','newWindow','toolbar=yes, location=0,directories=0,status=0,menubar=0,resize=1,scrollbars=yes,width=400,height=320'); return false">$msg{'view_file'}</a>
<li><a href="$script_admin?delete_files=1" target="newWindow"  onclick="window.open('$script_admin?delete_files=1','newWindow','toolbar=yes, location=0,directories=0,status=0,menubar=0,resize=1,scrollbars=yes,width=400,height=320'); return false">$msg{'file_delete'}</a>
<p>


&raquo; $msg{'author_menu'}
<li><a href="$script_admin?add_author=1">$msg{'author_menu_1'}</a>
<li><a href="$script_admin?view_author=1">$msg{'author_menu_2'}</a>
<p>

&raquo; $msg{'8'}
<li><a href="$script_admin?new_template=1">$msg{'9'}</a>
<li><a href="$script_admin?modify_template=1">$msg{'4'}</a>
<li><a href="$script_admin?view_template=1">$msg{'10'}</a>
<p>

&raquo; $msg{'666'}
<li><a href="$script_admin?search_view=1">$msg{'666_1'}</a>
<li><a href="$script_admin?view_category=1">$msg{'666_2'}</a>
<li><a href="$script_admin?rebuild_all=1">$msg{'666_3'}</a>
<p>
~;

if ($premoderate){
print qq~
&raquo; $msg{'com_menu'}
<li><a href="$comadmin_cgi_url?list=1">$msg{'com_edit'}</a>
<p>
~;
}	
print qq~
&raquo; $msg{'13'}
<li><a href="http://webscript.ru/sanitarium">$msg{'11'}</a>
<li><a href="http://forums.webscript.ru">$msg{'12'}</a>
<p>

&raquo; $msg{'home'}
<li><a href="$public_url/$index_page" target=_blank>$site_title</a>


</td></tr></table></td><td valign=top>
<table cellpadding=0 cellspacing=5 border=0  width="100%">
<tr><td width="100%">
<!-- main start-->
~;
}

sub head_html {
#--------------------------------------------------------------
print qq~
<html>
<head>
	<title>Sanitarium WebLoG - Admin Tools</title>
	$msg{'charset'}
~;
print &css_style;
print qq~
</head>
<body  topmargin=0	leftmargin=0 marginwidth=0 marginheight=0 bgcolor="#FFFFFF" text="#000000" link="#000000" alink="#b90000">
~;
}

sub css_style {
#--------------------------------------------------------------
return qq~
<STYLE TYPE="text/css">
body {
	 background-color:#FFFFFF;
	 color:#000000;
	 font-family:Verdana, Arial, "sans-serif";
     font-size: 10pt;
	 }
a {
  color:#000000;
  font-family:Verdana, Arial, "sans-serif";
  font-size: 10pt;
  text-decoration:none;
  
  }
a:link {text-decoration:none;}
a:hover {color:#b90000;
		text-decoration:none;
		}  
a:active {color:#b90000; text-decoration:underline;}		

.form0 {
	background-color:#f0f0f0;
	border:#000000 1 solid;
	color:#000000;
	font-size: 8pt;
	}
.form1 {
	background-color:#c0c0c0;
	border:#000000 1 solid;
	color:#000000;
	font-size: 8pt;
	}
.form2 {
	background-color:#f0f0f0;
	border:#000000 1 solid;
	color:#000000;
	font-size: 10pt;
	}
.txt {
      color:#000000;
	  font-family:Verdana, Arial, "sans-serif";
      font-size: 10pt;
	  margin-left: 10px;
	  margin-right: 10px;
	  text-align:justify;
	  line-height: 1.4em;
	  }

.news {
	  color:#000000;
	  font-family:Verdana, Arial, "sans-serif";
      font-size: 8pt;
	  }	
ul {list-style-type:circle;
    color:#b90000;
	list-style-position:inside;
	margin-left:0px;}	

.td0 { background-color:#dddddd;
	   color:#b90000;
	   font-family:Arial, "sans-serif";
   	   font-size: 10pt;
	   font-weight:bold;
   	   }
 .red {color:#b90000;
	  font-size:10pt;
	  font-weight:bold;
	  }
.td1 {
	background-color:#f0f0f0;
	border:#000000 1px solid;
	color:#000000;
	font-size: 8pt;
}	    	        
</STYLE>
~;
}	 


sub foot {
#--------------------------------------------------------------		
print qq~
<!-- main end-->
</DIV>
</td></tr></table></td></tr>
<tr><td valign=bottom NOWRAP><center><font class="txt"> 2002 &copy; <a href="http://webscript.ru">WebScript.Ru Network</a> All Rights Reserved</font></center>
</td></tr>
</table>
</body>
</html>
~;
}


sub table {
#--------------------------------------------------------------
my ($title, @content);
$title=shift;
@content=@_;
print qq~
<table cellpadding=0 cellspacing=0 border=0 class="td0" width="100%">
<tr><td width="100%">\&nbsp;|| $title </td></tr><tr><td>
<table cellpadding=5 cellspacing=1 border=0  width="100%">
<tr><td width="100%" bgcolor="#FFFFFF" class="txt">
@content
</td></tr></table></td></tr></table><br>
~;
}

sub input_form {
#--------------------------------------------------------------
#my ($iname, $size, $max, $val)=@_;
my $val=$_[3];
if ($val){$val=&for_form($val);}
else {$val='';}
return qq~
<input type=text name="$_[0]" value="$val" size="$_[1]" maxlength="$_[2]" class="form0"><br>
~;
}

sub textarea {
#--------------------------------------------------------------
my ($fname, $cols, $rows, $val)=@_;
if ($val){$val=&for_form($val);}
else {$val='';}
return qq~	
<textarea name="$fname" cols="$cols" rows="$rows" class="form2">$val</textarea>
<br>
~;
}

sub drop_list {
#-------------------------------------------------------------
my ($name, $mylist, $selected,  %list );
$name=shift;
$selected=shift;
$selected||='';
%list=@_;
#@list=@_;
#$list[0]||return 0;
#my $lst=$#list;
$mylist= qq~<select name=$name size=1 class="form0">~;
foreach my $key(keys %list){
	if ($key eq $selected){$mylist .= qq~<option SELECTED value=$key class="form0">$list{$key}~;}	
	else { $mylist .= qq~<option value=$key class="form0">$list{$key}~;}
}
$mylist .= qq~</select>~;
return $mylist; 
}	

sub js_drop_list {
#-------------------------------------------------------------
my ($name, $mylist, $event, $selected, $a_name, $a_mail, $a_signatures, $a_foto, $a_www, %list );
$name=shift;
$event=shift;
$selected=shift;
my ($checked1, $checked2);
$selected||='';
if ($selected=~/,,,/){
	$checked2='checked';
	$checked1='';
}
else {
	$checked1='checked';
	$checked2='';

	
}		

%list=@_;
$mylist= qq~
 $msg{'select_author'}
<br>
<script Language="JavaScript"> 

var _T = "locked";
var _F = "unlocked";
function lockIt(_P) 
 {
   var _L = 
   document.frm1.lck.value;
   if(_L==_P)return;
   
document.frm1.authorid.disabled=(document.frm1.lck.value=(_L==_F)?_T:_F)==_T;
}

function isDis() { 
return (document.frm1.lck.value==_T); 
}
</script>
<input type=radio value="my" $checked1 onclick="lockIt(_F)" id=radiom name=radiom><b> $msg{'reg_auth'}</b>
<br><select ID="authorid" name="authorid" class=form0 onfocus="if(isDis())blur();"> 
<option value='' class="form0">$msg{'author_select'}
~;
foreach my $key(keys %list){
		if ($key eq $selected){$mylist .= qq~<option SELECTED value=$key class="form0">$list{$key}~;}	
		else { $mylist .= qq~<option value=$key class="form0">$list{$key}~;}
}
if ($selected=~/,,,/){
	($a_name, $a_mail, $a_signatures, $a_foto, $a_www)=split(/,,,/, $selected);	
	#Parse for form:
	$a_www=&for_form($a_www);
	$a_signatures=&for_form($a_signatures);
	$a_mail=&for_form($a_mail);
	$a_name=&for_form($a_name);
}	
else {($a_name, $a_mail, $a_signatures, $a_foto, $a_www)=('','','','','');}
$mylist .= qq~</select>
<br>
<BR>
<input type=radio value="unreg" $checked2 onclick="lockIt(_T)" id=radiom name=radiom> <b>$msg{'unreg_auth'}</b>
<br>
<font class="td0">$msg{'author_name'}:</font>
<br>
<INPUT id=authname name=authname value="$a_name" size="40" maxlength="60" class=form0 onfocus="if(!isDis())blur();">
<br>
<font class="td0">$msg{'mail'}:</font>
<br>
<INPUT id=authmail name=authmail value="$a_mail" size="40" maxlength="60" class=form0 onfocus="if(!isDis())blur();"> 
<br>
<font class="td0">$msg{'foto'}:</font>
<br>
<INPUT id=authmail name=authfoto value="$a_foto" size="40" maxlength="60" class=form0 onfocus="if(!isDis())blur();"> 
<br>
<font class="td0">$msg{'www'}:</font>
<br>
<INPUT id=authwww name=authwww  value="$a_www" size="70" maxlength="150" class=form0 onfocus="if(!isDis())blur();"> 
<br>
<font class="td0">$msg{'signatures'}:</font>
<br>
<textarea id=authsignature name=authsignature  cols=60 rows=5 class=form0 onfocus="if(!isDis())blur();">$a_signatures</textarea> 
<input type=hidden name="lck" value="unlocked">
~;

return $mylist; 
}

sub file_list {
#---------------------------------------------------
my ($file, @file);
my $for_dir=shift;
opendir(FILE, $for_dir)||&WLerr("Can't open $foto_dir, reason: $!");
(undef,undef,@file)=readdir(FILE);
close FILE;	
return sort {$a cmp $b} @file;
}

sub print_file_list {
#----------------------------------------------------
my @fotos= &file_list($foto_dir);
my @img=&file_list($img_dir);
my $html = qq~
<table cellpadding=1 cellspacing=3 border=0>
<tr valign=top>
<td width="50%" bgcolor="#f0f0f0"><font color="#b90000" size=-1> &raquo; $msg{'upload_img'}</font><br>~;
foreach my $file(@img){
	next unless (-f "$img_dir/$file");
	$html .= qq~<li><a href="$img_url/$file">$file</a>\n~;
}
unless(@img){$html .= '<p> ..no files!';}
$html .= qq~</td><td width=1 bgcolor="#FFFFFF"></td><td bgcolor="#f0f0f0" width="50%"><font size=-1 color="#b90000"> &raquo; $msg{'upload_author'}</font><br>~;
foreach my $file(@fotos){
next unless (-f "$foto_dir/$file");
$html .= qq~<li><a href="$foto_url/$file">$file</a>\n~;
}
unless(@fotos){$html .= '<p> ..no files!';}
$html .= qq~</td></tr></table>~;
&print_header;
&head_html;
&table($msg{'view_file'}, $html);
print "</body></html>";
}

sub delete_files {
#---------------------------------------------------
my (@fotos, @img, $html);
if (! $in{'delete_this'}){
	@fotos= &file_list($foto_dir);
	@img=&file_list($img_dir);
	$html = qq~
	<form action="$script_admin" method=POST>
	
	<table cellpadding=1 cellspacing=3 border=0>
	<tr valign=top>
	<td width="50%" bgcolor="#f0f0f0"><font color="#b90000" size=-1> &raquo; $msg{'upload_img'}</font><br>~;
	foreach my $file(@img){
	$html .= qq~<input type=checkbox name="img" value="$file"><a href="$img_url/$file">$file</a><br>\n~;
	}
	unless(@img){$html .= '<p> ..no files!';}
	$html .= qq~</td><td width=1 bgcolor="#FFFFFF"></td><td bgcolor="#f0f0f0" width="50%"><font size=-1 color="#b90000"> &raquo; $msg{'upload_author'}</font><br>~;
	foreach my $file(@fotos){
	$html .= qq~<input type=checkbox name="foto" value="$file"><a href="$foto_url/$file">$file</a><br>\n~;
	}
	unless(@fotos){$html .= '<p> ..no files!';}
	$html .= qq~</td></tr></table>~;
        &print_header;
	&head_html;
	&table($msg{'file_delete'}, $html);
	print qq~
	&nbsp;&nbsp;<input type=SUBMIT name="delete_this" value="Delete!" class="form1"></form>
	</body></html>
	~;
}
else {
	if ($in{'img'}){ 
		@img=split(/,/,$in{'img'});
		$html = qq~ <font color="#b90000">Img Dir: $img_dir</font><br> ~;
		foreach my $file(@img){
			if (-e "$img_dir/$file"){
				unlink "$img_dir/$file";
				$html .= "<li> $file deleted!" unless (-e "$img_dir/$file");
			}
			else { $html .= qq~<li> <font color="#b90000">$file</font> $msg{'not_deleted'}~;}
		}
	}
	if ($in{'foto'}){
		@fotos=split(/,/,$in{'foto'});
		$html .= qq~<br> <font color="#b90000">Foto Dir: $foto_dir</font><br> ~;
		foreach my $file(@fotos){
			if (-e "$foto_dir/$file"){
				unlink "$foto_dir/$file";
				$html .= "<li> $file deleted!" unless (-e "$foto_dir/$file");
			}
			else { $html .= qq~<li> <font color="#b90000">$file</font> $msg{'not_deleted'}~;}
		}
	}
	&print_header;
	&head_html;		
	&table($msg{'files_deleted'}, $html);	
 	print "</body></html>";

}
#end sub
}



#.........#TEMPLATES
####################
sub template_list {
#----------------------------------------------------				
my ($my_tmp, $my_file, @my_tmps);
$my_tmp=shift;
$my_tmp||='';
opendir(TMP,$tmpl_dir)||&WLerr("Can't open $tmpl_dir, reason:$!");
while (defined($my_file=readdir(TMP))){
	if ($my_file=~/tmp-.*\.txt/){
	$my_file =~ s/\.txt//g;
	if ($my_file eq $my_tmp){unshift(@my_tmps,$my_tmp, $my_tmp);}
	else {push(@my_tmps,$my_file,$my_file );}
	}
}
closedir(TMP);
return @my_tmps;
}


#.........#ERRORS
#################

sub msg {
#----------------------------------------------------------
&head;
&table($msg{'att'}, @_);
&foot;
exit;
}

#.........#PARSE_TEXT
#####################
sub parse_article {
#---------------------------------------------------------
my $text=shift;
#For <!--MY CODE--> <!--END CODE --> works like <pre>
$text=~s/(<!--.*?-->|<(?:[pP]|[bB][Rr]|[Pp][rR][Ee])>)/$1\n/g;
if ($text=~/MY CODE/){
	my $lin;
	my $code_here;
	my @entry=split(/\n/,$text);
	foreach  $lin(@entry) {
		if($lin =~ /MY CODE/) {
		 	$code_here = 1; 
			next; 
		}
	
		next unless ($code_here);
		if($lin =~ /END CODE/) { 
			$code_here = 0;
			next;
		}
		$lin =~ s/<BR>//g;
		$lin =~ s/\&/\&amp;/g;
		#$lin =~ s/  /&nbsp;/g if $code_here;
		$lin =~ s/</\&lt;/g;
		$lin =~ s/>/\&gt;/g;
		$lin =~ s/"/\&quot;/g;
		$lin .="<BR>\n";
		}
	$text=join("\n", @entry);
	$text=~s/(?:<BR>\s+)+/<BR>\n/g;
}
$text=~s/[\n\r]+/\n/g;
#AutoLink
if ($autolink){
$text=~s/([\s|\(]|<br>|<p>|\A)(http:\/\/|ftp:\/\/|mailto:|https:\/\/)([^\s'"<>]+)/$1<a href="$2$3" target=_blank>$3<\/a>/g;
}
	
#IF USE EMOTICONS:
if ($use_emoticons){
	$text=~ s/\s\Q:)\E\s/ \<img src=$img_url\/smile\.gif width=15 height=15 alt=":)"\> /g;
	$text =~ s/\s\Q:-)\E\s/ \<img src=$img_url\/smile\.gif width=15 height=15 alt=":-)"\> /g;
	$text =~ s/\s\Q:-(\E\s/ \<img src=$img_url\/sad.gif width=15 height=15 alt=":-("\> /g;
	$text =~ s/\s\Q:(\E\s/ \<img src=$img_url\/sad.gif width=15 height=15 alt=":("\> /g;
	$text =~ s/\s\Q8)\E\s/ \<img src=$img_url\/cool.gif width=15 height=15 alt="8)"\> /g;
}
return $text;		
#end sub	
}	

sub text_to_form {
#--------------------------------------
my $text=shift;
#$text =~ s/&([\w\d#]+;)/\&amp;$1/g;
$text=~s/(<!--.*?-->|<(?:[Pp]|[bB][Rr]|[Pp][rR][eE])>)/$1\n/g;
$text =~ s/&nbsp;/&amp;nbsp;  /g;
$text =~ s/</&lt;/g;
$text =~ s/>/&gt;/g;
$text =~ s/"/&quot;/g;
if ($text=~/MY CODE/){
	my $lin;
	my $code_here;
	my @entry=split(/\n/,$text);
	foreach  $lin(@entry) {
		if($lin =~ /MY CODE/) {
		 	$code_here = 1; 
			next; 
		}
		next unless ($code_here);
		if($lin =~ /END CODE/) { 
			$code_here = 0;
			next;
		}
		$lin =~ s/<BR>/\n/g;
	}
	
	$text=join("\n", @entry);
	$text=~s/(<BR>\s+)+/$1/g;
}
$text=~s/[\n\r]+/\n/g;
return $text;
}	
	
sub for_form {
#---------------------------------------------
my $text=shift;
$text =~ s/</&lt;/g;
$text =~ s/>/&gt;/g;
$text =~ s/"/&quot;/g;
return $text;
}		
	
sub emoticons_to_symbol {
#---------------------------------------------
my $text=shift;
$text=~ s/\s<img src=.*?alt="(\W+)">\s/ $1 /g;
return $text;
#end sub
}



#.........#TEMPLATE EDITOR
##########################

sub select_template {
#----------------------------------------------------
my $my_html = qq~
<form action="$script_admin" METHOD="POST">
~;
$my_html .=&drop_list('template','',&template_list);
$my_html .=qq~<br>
<input type=radio name=tmplist value="index"> $msg{'tmp_index'}<br>
<input type=radio name=tmplist value="article"> $msg{'tmp_article'}<br>
<input type=radio name=tmplist value="mail"> $msg{'tmp_mail'}<br>
<input type=radio name=tmplist value="comment"> $msg{'tmp_comment'}<br>
<INPUT TYPE="SUBMIT" NAME="new_template" VALUE="OK!" class="form1">
<br><font class="news"><a href="$script_admin?view_template=1" target=_blank><u><small>Click here</small></u></a> and view templates</font>
~;
&head;
&table('Select Template', $my_html);
&foot;
}


sub template_edit {
#---------------------------------------------------
my ($template, $file,  $my_html,  %rec);
my %tmplist=('index'  =>['index', 'preview', 'menu_row', 'drop_list', 'news'],
             'article'=>['article', 'related','foto'],
             'mail'   =>['mail', 'mailform', 'print'],
             'comment'=>['view_comments', 'comment']);


#Modify template or create new?
$template=$in{'template'} if $in{'template'};


#Name templates files
#@tmp=('index', 'article');
#@tmp2=('preview', 'menu_row', 'related', 'drop_list', 'print', 'mail', 'news');

#Load Template Data
if ($template){
	foreach $file (@{$tmplist{$in{'tmplist'}}}){
		if (-e "$tmpl_dir/$template/$file.txt"){
			&WLopen("<$tmpl_dir/$template/$file.txt",1);
			foreach my $line(<TEXT>){$rec{$file} .=$line;}
			close TEXT;
			$rec{$file}=~s/</&lt;/g;
			$rec{$file}=~s/>/&gt;/g;
			$my_html =$msg{'49'}.' '.$template.' '.$msg{'50'};
		}
	
	}
	

}
else {
	$|++;
	&head;
	print qq~
	<form action="$script_admin" METHOD="POST">
	~;
	$my_html = qq~
	$msg{'62'}<br>
	<input type=text name="template" value="tmp-" size="50" maxlength="50" class="form2">
	~;	
	&table('Template Name', $my_html);
	
	$my_html = qq~
	<textarea name="desc" cols="50" rows="10" class="form0"></textarea>
	~;
	&table($msg{'temp_desc'}, $my_html);
	print qq~
	<INPUT TYPE="SUBMIT" NAME="new_templ_but" VALUE="Create Template!" class="form1"></form>
	~;
	&foot;
	exit;
}
	
$my_html .=' '.$msg{'51'};
&head;
print qq~
<form action="$script_admin" METHOD="POST">
~;

#About Templates
&table('Template Builder', $my_html);

#Template Name
$my_html = qq~
	<input type=hidden name="template" value="$template">
	<input type=hidden name="tmplist" value="$in{'tmplist'}">
	<b>$template</b>
	~;
&table('Template Name', $my_html);

#Now build textarea input field for each template
my $rows=15;
foreach my $line(@{$tmplist{$in{'tmplist'}}}){
	$rows=40 if $line=~/(?:index|article|mailform|view_comments|mail)/;
	$my_html = qq~
	<textarea name="$line" cols="50" rows="$rows" class="form2">$rec{$line}</textarea>
	~;
	&table($line, $my_html);
	$rows=15;
}

if ($in{'tmplist'} eq 'index'){
#Template description
	&WLopen("<$tmpl_dir/$template.txt",1);
	foreach my $line (<TEXT>){$rec{'desc'} .=$line;}
	close TEXT;

	$my_html = qq~
	<textarea name="desc" cols="50" rows="20" class="form0">$rec{'desc'}</textarea>
	~;
	&table($msg{'temp_desc'}, $my_html);
}
#Buttons
print qq~
<INPUT TYPE="SUBMIT" NAME="mod_templ_but" VALUE="Modify Template!" class="form1"></form>
~;
&foot;
}

sub save_template {
#----------------------------------------------------
my ($option, $line, @input);
my %tmplist=('index'  =>['index', 'preview', 'menu_row', 'drop_list', 'news'],
             'article'=>['article', 'related','foto'],
             'mail'   =>['mail', 'mailform', 'print'],
             'comment'=>['view_comments', 'comment']);

#New Template (=1) or Modify Old Template?
$option=shift;
if ($option){
	@input=('template','desc');
	#Check users input data
	foreach $line(@input){
		if (!$in{$line}){&msg("$msg{'30'}: $line!")}
	} 
	$in{'template'} =~ s/[\&;\`'\|\"*\?\~\^\(\)\[\]\{\}\$\n\r]/san/g;
	if(-e "$tmpl_dir/$in{'template'}"){&WLerr("Template with name $in{'template'} alredy exists, rename your ner template!");}
	unless(mkdir("$tmpl_dir/$in{'template'}", 0777)){&WLerr("Can't mkdir $in{'template'}, reason: $!");}
	unless(chmod (0777, "$tmpl_dir/$in{'template'}")){&WLerr("Can't chmod $tmpl_dir/$in{'template'}, reason: $!");}
	#Print Template Description
	&WLopen( ">$tmpl_dir/$in{'template'}.txt", 2);
	print TEXT $in{'desc'};
	close TEXT;
	&select_template;	
}
else {
	#Print Template files
	foreach $line (@{$tmplist{$in{'tmplist'}}}){
			&WLopen( ">$tmpl_dir/$in{'template'}/$line.txt", 2);
			print TEXT $in{$line};
			close TEXT;
	}
	if ($in{'desc'}){
		#Print Template Description
		&WLopen( ">$tmpl_dir/$in{'template'}.txt", 2);
		print TEXT $in{'desc'};
		close TEXT;
	}

	&head;
	&table('Template Saved', "$msg{'67'} $in{'template'}");
	&foot;
}
}

sub view_template {
#--------------------------------------------------------------
my ($file, $temp_info, @templates);
opendir(TMP,"$tmpl_dir")||&WLerr("Can't open $tmpl_dir, reason:$!");
while ($file=readdir(TMP)){if ($file=~/tmp-.*?\.txt/){push(@templates,$file);}}
closedir(TMP);
$file='';
&head;
foreach $file(@templates){
	open ('TEMPLATE', "<$tmpl_dir/$file");
	$file =~ s/\.txt//g;
	$temp_info = qq~ <b>$file: </b>~;
	while (<TEMPLATE>){$temp_info .=$_;}
	close TEMPLATE;
	&table($file, $temp_info);
}
&foot;
}	

#........START
##############

sub start_page {
#--------------------------------------------
&head;
&table('Hello, Admin!', $msg{'hello'});
if (!-e "$data/categories.dat"){
	&table('Are you ready?', qq~
	$msg{'start_tip'}<br>
	<li><b>$msg{'6'}:</b><a href="$script_admin?new_cat=1">$msg{'7'}!</a>
	~);
}	
&foot;
}

#..............BUILDER
######################

#..........................................................#
#	Take a look to the sky just before you die
#	It is the last time you will
#...................	Metallica, "For Whom The Bell Tolls"  

sub rebuild_category {
#-----------------------------------------------
my $cat=shift;
my $timer=time();
$cat||=$in{'cat_id'};
if ($cat){
&load_cfg($cat);
$builder->build_category($cat);
if ($in{'rebuild_cat'}){
	&index_print('index');
	&end_rebuild('category', $cat, (time()-$timer));}
}
else {&WLerr("ERROR: category ID not defined!");}
#end sub
}	

sub rebuild_all {
#----------------------------------------------
my $cat=($in{'cat_num'}||'0');
my $obj= new Sanitarium_WL("$data/categories", 'categories');
my @cats= sort {$a cmp $b} $obj->get_keys();
$obj=0;
my $timer=time();
&rebuild_category($cats[$cat]);
$cat++;
if ($cat==($#cats+1)){
	&index_print('index');
	&end_rebuild('all');
	}
else {
	&print_header;
	print qq~
	<html>
	<head>
	<title>Sanitarium - Rebuilding WebLog...</title>
	<meta HTTP-EQUIV="Refresh" CONTENT="3; URL=$script_admin?rebuild_all=1&cat_num=$cat">
	~;
	print &css_style;
	print qq~</head><body  topmargin=0	leftmargin=0 marginwidth=0 marginheight=0 bgcolor="#FFFFFF" text="#000000" link="#000000" alink="#b90000">~;
	my $html = "$cats[$cat-1] rebuild: ".(time()-$timer)."sec<br>";
	$html .=$msg{'cat_rebuild'};
	$html .= qq~<br> <a href="$script_admin?rebuild_all=1&cat_num=$cat"><b>$msg{'rebuild_next'}</b></a>~;
	&table($msg{'r_t_cat'}, $html);
}  
#end sub
}	

sub article_rebuild {
#---------------------------------------------
my $id=$in{'id'};
my $cat=$in{'cat_id'};
unless ($cat){&WLerr("Category ID not defined!");}
unless ($id){&WLerr("Article ID not defined!");}
my $timer=time();
if ($static_pages){	
	&load_cfg;
	#if ($in{'page'}){$builder->build_article($id, $cat, $in{'page'});}
	#else {
	$builder->build_article($id, $cat);
	$builder=0;
	#	}
}		
	&index_print($cat);
	&index_print('index');
	&end_rebuild('article', $id, (time()-$timer)) if $in{'article_rebuild'};
	}	

sub end_rebuild {
#----------------------------------------------
my $text;
my $option=shift;
if ($option eq 'all'){$text=$msg{'all_rebuild'};}
elsif ($option eq 'category'){$text="ID: $_[0] $msg{'cat_rebuild_end'} $_[1] sec.";}
else {$text="ID: $_[0] $msg{'article_rebuild'}<br>$_[1] sec.";}
&head;
&table('Rebuild Complete!', $text);
&foot;
#end sub
}	

sub index_print {
#-----------------------------------------------
my ($cat_id, $obj, $to, $num, @from_db);
$cat_id=shift;
$obj= new Sanitarium_WL("$data/$cat_id", 'index');
@from_db=$obj->get_keys();
if (@from_db){@from_db= sort {$b<=>$a} @from_db;}        
else {@from_db=0}
$obj=0;
&load_cfg($cat_id);
$builder->print_index_page(@from_db);
	
}

sub load_cfg {
#----------------------------------------------
my ($cat_id, $cat_url, $template, $page)=@_;
$cat_id||='';
$cat_url||='';
$template||='';
$page||=0;

#GLOBAL:
$builder= new Sanitarium_WL;
$builder->load_cfg($site_title,
                    $public_url,
                    $index_page,
                    $ext,
                    $index_url,
                    $entry_per_page,
                    $static_pages,
                    $data,
                    $tmpl_dir,
                    $public_dir,
                    $view_cgi_url,
                    $comment_url,
                    $how_news,
                    $txt_news,
                    $foto_url,
                    $cat_id,
                    $cat_url,
                    $template,
                    $page);
#end sub
}

###############################################################
#                   INDEXING ARTICLES                         #
###############################################################

sub index_text {
#------------------------------------
my $page=shift;

# RUSSIANS, WARNING! 
# @word_ends and @stop_words in win-1251 encoding!!
# if you work in koi8-r, then you must translate @word_ends and @stop_words into koi8-r
my @word_ends= qw/ies        in g       \-            ed           es                    s/;
my @stop_words= qw/                          have by            not will you there and \- all  with   are  would the   can any was    from   about   that   for which   but   what one they this /;

# BIG RUSSIAN LETTERS \xC0-\xDF\xA8 (xA8 - )
# small russian letters \xE0-\xFF\xB8' (xB8 - )

$page=~s/<[^>]+>/ /g;#Strip ALL HTML Tags
$page=~s/&[\w]+;//g;#Strip ALL HTMLs like &lt;
$page=~tr/A-Z\xC0-\xDF\xA8/a-z\xE0-\xFF\xB8/;#BIG to small

map{$page=~s/$_[^a-z\xE0-\xFF\xB8]/ /g if length($_)>3} @word_ends;#Delete word ends
map($page=~s/[^a-z\xE0-\xFF\xB8]$_[^a-z\xE0-\xFF\xB8]/ /g, @stop_words);#Delete stop words
$page=~s/([-a-z\xE0-\xFF\xB8])\1+/$1/g;#Delete double symbols
my(@words) = split(/[^-a-z\d\xE0-\xFF\xB8]+/, $page);#Delete non alphabetic symbols and splite to array
undef $page;
@words=grep{length > 2} @words;#Delete all words from 1 or 2 symbols
my %count=();
foreach (@words){
	if(length==5){s/.$//;}
	elsif(length==6||length==7){s/..$//;}
	elsif(length==8||length==9){s/...$//;}
	elsif(length>9){s/....$//;}
	$count{$_}++;
}
map {delete $count{$_}} grep($count{$_}==1, keys %count);#delete uniq/original words (in theory, useless for content) 
return %count;
}	

sub get_article_content {
#---------------------------------------------
my $id=shift;
my $cat=shift;
my $obj= new Sanitarium_WL("$data/$cat/$id", 'article');
my %art=$obj->get_nn_recs('all');
my %content=();
foreach my $key(keys %art){
	my %temp=$obj->unpack_to_hash($art{$key});
	$content{$key}=$temp{'title'}.' '.$temp{'title'}.' '.$temp{'title'}.' '.$temp{'content'};#More title relevant
}	
$obj=0;
undef %art;
return %content;
#end sub	
}

sub indexing_article {
#---------------------------------
unless ($use_search){return 0;}
my $id=$in{'id'};
my $cat=$in{'cat_id'};
my %to_index=&get_article_content($id, $cat);
my $obj= new Sanitarium_WL("$data/search", '');
foreach my $key(keys %to_index){
	my %count=&index_text($to_index{$key});
	$obj->add_to_index(($id.'_'.$key), %count);
}
&head;
&table($msg{'add_to_index'}, "id: $id ".$msg{'indexing'});
	
&foot;		
}

sub indexing_page {
#----------------------------------
unless ($use_search){return 0;}
my $cat=shift;
my $id=shift;
my $pag=shift;
$id||=$in{'id'};
$cat||=$in{'cat_id'};
$pag||=($in{'num'}||$in{'page'});
my $obj= new Sanitarium_WL("$data/$cat/$id", 'article');
my %to_index=$obj->get_data($pag);
$obj=0;
my %count=&index_text($to_index{'title'}.' '.$to_index{'title'}.' '.$to_index{'content'});
$obj= new Sanitarium_WL("$data/search", '');
$obj->add_to_index(($id.'_'.$pag), %count);
}

sub delete_from_index_all {
#-----------------------------------
unless ($use_search){return 0;}
my $id=$in{'id'};
$id||=shift;
my $cat=$in{'cat_id'};
$cat||=shift;
my %to_index=&get_article_content($id, $cat);
my $obj= new Sanitarium_WL("$data/search", '');
my $old_data=join(' ', values %to_index);
undef %to_index;
my %count=&index_text($old_data);
$obj->delete_from_index_all($id, %count);
}

sub delete_page_from_index {
#----------------------------------
unless ($use_search){return 0;}
my $cat=shift;
my $id=shift;
my $pag=shift;
$pag||=($in{'num'}||$in{'page'});
$id||=$in{'id'};
$cat||=$in{'cat_id'};
my $obj= new Sanitarium_WL("$data/$cat/$id", 'article');
my %to_index=$obj->get_data($pag);
$obj=0;
$obj= new Sanitarium_WL("$data/search", '');
my %count=&index_text($to_index{'title'}.' '.$to_index{'title'}.' '.$to_index{'title'}.' '.$to_index{'content'});
$obj->delete_from_index($id, %count);
}

##############################################################
#                        AUTHORS                             #
##############################################################
# Add New Author
# Modify Author
# Delete Author
# View Author/All Authors

sub add_author {
#-----------------------------------------------------------
my ($obj, $submit, $val, %author);
if ($in{'modify_author'}&&$in{'author_id'}){
	$obj = new Sanitarium_WL("$data/authors", 'authors');
	%author=$obj->get_data($in{'author_id'});
	$submit='save_mod_author';
	$val=$msg{'mod_author'};

}
else {
	$submit='save_new_author';
	$val=$msg{'add_author'};
	}
&head;
print qq~<form action="$script_admin" METHOD="POST">~;
print qq~<input type=hidden name="author_id" value="$in{'author_id'}">~ if $in{'author_id'};
&table($msg{'author_name'}, &input_form('name', 70, 70, $author{'name'}));
&table($msg{'mail'}, &input_form('mail', 70, 70, $author{'mail'}));		
&table($msg{'signatures'}.':', &textarea('signatures', 60, 3, $author{'signatures'}));

if ($author{'foto'}){print qq~<img src="$foto_url/$author{'foto'}"><br>~;}
&table($msg{'foto'}, &input_form('foto', 20, 20, $author{'foto'}));
#&upload_foto_html;
	
#######GO To EaT!	
&table($msg{'www'}.':', &input_form('www', 80, 350, $author{'www'}));
#&table($msg{'www_name'}.':', &input_form('www_name', 70, 150, $author{'www_name'}));
print qq~<input type=SUBMIT name="$submit" value="$val" class="form1"></form>~;
#
}	

sub save_author {
#--------------------------------------------
#'authors' =>['name', 'mail', 'signatures', 'foto', 'www_url', 'www_name'],
my $author_id;
unless ($in{'name'}&&$in{'mail'}){
	&msg("$msg{'not_defined'} name or mail !<br>$msg{'back'}");
}
my $obj=new Sanitarium_WL("$data/authors", 'authors');
if ($in{'save_new_author'}){
	$author_id=$obj->write_data('1auth',
	                            $in{'name'},
	                            $in{'mail'},
	                            $in{'signatures'},
	                            $in{'foto'},
	                            $in{'www'});
}
else {
	       $obj->modify_data(   $in{'author_id'},
	                            $in{'name'},
	                            $in{'mail'},
	                            $in{'signatures'},
	                            $in{'foto'},
	                            $in{'www'});
	$author_id=$in{'author_id'};
}
&author_info($author_id);
#end sub
}	

sub author_info {
#-----------------------------------------------------------
my $author_id=shift;
$author_id||=$in{'author_id'};
my ($obj, $html, %author);
$obj=new Sanitarium_WL("$data/authors", 'authors');
if ($author_id){
	%author=$obj->get_data($author_id);
	$html= qq~
	<li> <b>ID:</b> $author_id
	<li> <b>$msg{'author_name'}:</b> $author{'name'}
	<li> <b>$msg{'mail'}:</b>  $author{'mail'}
	<li> <b>$msg{'signatures'}:</b> <i>$author{'signatures'}</i>
	<li> <b>foto: $author{'foto'}:</b>
~;
if ($author{'foto'}){ $html .= qq~	
	<br><img src="$foto_url/$author{'foto'}">
~;
}
$html .= qq~		
	<li> <b>$msg{'www'}:</b> $author{'www'}
	<p>
	<a href="$script_admin?author_id=$author_id&modify_author=1">:$msg{'modify'}</a>
	<a href="$script_admin?author_id=$author_id&delete_author=1">:$msg{'delete'}</a>
	~;
	&head;
	&table($author{'name'}, $html);
	&foot;
}
else {
	$html = qq~
	<form action="$script_admin" METHOD="POST">
	~;
	$html .=&drop_list('author_id','',&authors_list);
	$html .= qq~
	<INPUT TYPE="SUBMIT" NAME="view_author" VALUE="OK!" class="form1">
	~;
	&head;
	&table($msg{'Author'}, $html);
	&foot;
}
#end sub
}	

sub delete_author {
#----------------------------------------------------------
my ($obj, $html, %author);
$obj= new Sanitarium_WL ("$data/authors", 'authors');
%author=$obj->get_data($in{'author_id'});
$html= qq~
	<li> <b>ID:</b> $in{'author_id'}
	<li> <b>$msg{'author_name'}:</b> $author{'name'}
	<li> <b>$msg{'mail'}:</b>  $author{'mail'}
	<li> <b>$msg{'signatures'}:</b> $author{'signatures'}
~;
if ($author{'foto'}){ $html .= qq~	
	<br><img src="$foto_url/$author{'foto'}">
~;
}
$html .= qq~	
	<li> <b>$msg{'www'}:</b> $author{'www'}
	
	<p>
~;
unless ($in{'del_author'}){
	#Build category Info
	$html .= qq~
	$msg{'author_del'}
	<p>
	<a href="$script_admin?author_id=$in{'author_id'}&delete_author=1&del_author=1"><b>$msg{'yes_del_author'}</b></a>
	~;
	&head;
	&table($msg{'att'}, $html);
	&foot;
}
else {
	$obj->delete_data($in{'author_id'});
	$obj=0;
	$html .=$msg{'author_daleted'};
	&head;
	&table($msg{'att'}, $html);
	&foot;
}	
}

sub get_author_name {
#-----------------------------------------------------------
my $name=shift;
my @author;	
if ($name=~/,,,/){
	@author=split(/,,,/, $name);
	return $author[0];
}
else {		
	my %auths=&authors_list;
	if (exists $auths{$name}){return $auths{$name};}
}		
return $name;
}

sub authors_list {
#----------------------------------------------------------
my ($obj, @keys, @list, %authors);

$obj = new Sanitarium_WL("$data/authors", 'authors');
%authors = $obj->get_nn_recs('all', '', 1);
#'authors'     =>['name', 'mail', 'signatures', 'foto', 'www'],
@keys= keys %authors;
foreach my $man(@keys){
	my %auth=$obj->unpack_to_hash($authors{$man});
	push(@list,$man,$auth{'name'});
}
$obj=0;
return @list;
}

######################## UTILITES ############################
sub print_header {
#--------------------------------------------------------------	
print "Content-type: text/html\n";
#print "Expires: Mon, 31 Dec 2001 23:59:00 GMT\n";
#print "Cache-Control: no-cache, must-revalidate\n";
print "Pragma: no-cache\n\n";

}

sub parse_form {
#--------------------------------------------------------------
my ($buffer, $val, $key, $line_parse, @parse, %parse_data);

if ($ENV{'REQUEST_METHOD'} eq 'GET') {
	@parse = split(/&/, $ENV{'QUERY_STRING'});
    }
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
        @parse = split(/&/, $buffer);
    }
else {&WLerr("This cant access (Telnet/SHH?)!");}
foreach $line_parse(@parse) {
$line_parse =~ tr/+/ /;
($key, $val) = split(/=/, $line_parse);
$key =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
if (defined($parse_data{$key})){$parse_data{$key} .= ",$val";}
else {$parse_data{$key} = $val;}
}
return %parse_data;
}


sub WLerr {
#--------------------------------------------------------------
&print_header;
print @_;
exit;
}

